/* Program pro demostraci metod rozpoznavani - Bayesovo kriterium
 *   @author Ondrej Rohlik
 *   @version JDK 1.1.7a (a JWS tj, asi 1.1.3)
 */

import java.applet.*;
import java.awt.event.*;
import java.awt.image.*;
import java.awt.*;
import java.lang.String;

/** Hlavni trida programu Morse
* @author Ondrej Rohlik
*/
public class Morse extends java.applet.Applet 
implements /*Runnable,*/ ImageObserver {

  static public Color barvaPozadi = new Color(200, 161, 112); //old and Good
  //static public Color barvaPozadi = new Color(179, 143, 99);//newer and Bad
  static int	maxDelkaPismena = 4;
  static int	velKroku = 100;      //100 miliskeunk ... pro histogram
  static int	maxDelkaZnaku = 1000; //1000 milisekund ... jasna carka
  static int	minPocetTreninku = 5;
  static int	pocetIntervalu = maxDelkaZnaku/velKroku;
  public Object morse;
  public Panel	panel1, panel2, panel3;
  public Panel  severni, jizni, vychodni, zapadni, stredni;
  public Zalozky zalozky;
  public Image		  panelImg1, panelImg2, panelImg3, zalozkyImg;
  public Image		  jizniImg, zapadniImg, severniImg, vychodniImg, stredniImg;
  public Graphics	  panelGr1, panelGr2, panelGr3, zalozkyGr;
  public Graphics	  jizniGr, zapadniGr, severniGr, vychodniGr, stredniGr;
  public java.util.Date	  cas;
  public long		  cas1, cas2;
  public ImageButton bTrenovat;
  public ImageButton bDalsi;
  public ImageButton bZpet; 
  public ImageButton bPlay;
  public ImageButton bRecord;
  public ImageButton bRewind;
	public ImageButton bPodrobnosti;
  public Klic	      klic;
  public Tracker      trackerThread;
  public Trener	      trener;
  public Klasifikator klasifikator;
  public Animator     animator;
  public Image imgEin, imgUvod, imgMenu, imgTrenOff, imgTrenOn;
  public Image imgKlicOn, imgKlicOff, imgPlayOn, imgPlayOff;
  public Image imgRecordOn, imgRecordOff, imgRewindOn, imgRewindOff;
  public Image imgDalsiOff, imgDalsiOn, imgZpetOff, imgZpetOn;
  public Image imgPodrobOff, imgPodrobOn, imgSipka;
  public Image imgInfo, imgTren, imgKlas, imgMorse;
  public Image imgZalozky[][], imgZalozkyLast;
  public MediaTracker tracker;
  public AudioClip clipOK, clipBad, clipPip;
  public AudioClip clipUvod, clipNavod, clipTrenovani, clipKlasifikace;
  public char poleZnaku[]; 	 //pole pro jedno Pismeno morseovky . - ?
  public long polePriznaku[];    //pole vzorku, teprve nutno rozpoznat
  public int poleNatrenovanychCetnosti[][];   //  N(x|w)
  public float poleNatrenovanychCetnostiX[];  //  N(x)
  public float poleNatrenovanychPpstiX[];     //  p(x)
  public float poleNatrenovanychPpsti[][];    //  p(x|w)
  public float poleAposteriornichPpsti[][];   //  p(w|x) 
  public float poleApriornichPpsti[] = {0.55f, 0.45f};  // tecka, carka p(wi)
  public String rozpoznanePismeno;
  public int aktivniOkno = 0;
  public int kolikatyZnak = 0;
  public int kolikatyTrenink = 0;
  public boolean konecTrenovani = false;

/***********************************************************************/
/***********************************************************************/
/***********************************************************************/

  public void init() {
    int i;
    morse = this;
    poleZnaku = new char[10];
			for (i=0; i<10; i++)
				poleZnaku[i] = '?';
    polePriznaku = new long[10];
    poleNatrenovanychPpstiX	= new float[maxDelkaZnaku/velKroku];
    poleNatrenovanychCetnostiX	= new float[maxDelkaZnaku/velKroku];
    poleNatrenovanychCetnosti	= new int[2][maxDelkaZnaku/velKroku];
    poleNatrenovanychPpsti	= new float[2][maxDelkaZnaku/velKroku];
    poleAposteriornichPpsti	= new float[2][maxDelkaZnaku/velKroku];
    for (i = 0; i < 10; i++)
      polePriznaku[i] = 0;
		imgZalozky = new Image[2][6]; 
    //inicializace vsech medii
    clipOK	= getAudioClip(getCodeBase(), "sound/ok.au");
    clipBad	= getAudioClip(getCodeBase(), "sound/bad.au");
    clipPip	= getAudioClip(getCodeBase(), "sound/pip.au");
    clipUvod	=				getAudioClip(getCodeBase(), "sound/Uvod.au");
    clipNavod	=				getAudioClip(getCodeBase(), "sound/Navod.au");
    clipTrenovani	=		getAudioClip(getCodeBase(), "sound/Trenovani.au");
    clipKlasifikace	= getAudioClip(getCodeBase(), "sound/Klasifikace.au");
    imgUvod	= getImage(getCodeBase(), "img/Uvod.gif");
    imgTrenOff	= getImage(getCodeBase(), "img/tl/ObdBrwnTrenOff.gif");
    imgTrenOn	= getImage(getCodeBase(), "img/tl/ObdBrwnTrenOn.gif");
    imgKlicOff	= getImage(getCodeBase(), "img/tl/ObdBrwnKlicOff.gif");
    imgKlicOn	= getImage(getCodeBase(), "img/tl/ObdBrwnKlicOn.gif");
    imgRewindOff	= getImage(getCodeBase(), "img/tl/CtvBrwnRewOff.gif");
    imgRewindOn	= getImage(getCodeBase(), "img/tl/CtvBrwnRewOn.gif");
    imgPlayOff	= getImage(getCodeBase(), "img/tl/CtvBrwnPlayOff.gif");
    imgPlayOn	= getImage(getCodeBase(), "img/tl/CtvBrwnPlayOn.gif");
    imgRecordOff	= getImage(getCodeBase(), "img/tl/CtvBrwnRecOff.gif");
    imgRecordOn	= getImage(getCodeBase(), "img/tl/CtvBrwnRecOn.gif");
    imgTrenOff	= getImage(getCodeBase(), "img/tl/ObdBrwnNoveOff.gif");
    imgTrenOn	= getImage(getCodeBase(), "img/tl/ObdBrwnNoveOn.gif");
    imgDalsiOff	= getImage(getCodeBase(), "img/tl/ObdBrwnDalsiOff.gif");
    imgDalsiOn	= getImage(getCodeBase(), "img/tl/ObdBrwnDalsiOn.gif");
    imgZpetOff	= getImage(getCodeBase(), "img/tl/ObdBrwnZpetOff.gif");
    imgZpetOn	= getImage(getCodeBase(), "img/tl/ObdBrwnZpetOn.gif");
    imgPodrobOff	= getImage(getCodeBase(), "img/tl/PodrobnostiOff.gif");
    imgPodrobOn	= getImage(getCodeBase(), "img/tl/PodrobnostiOn.gif");
		imgSipka = getImage(getCodeBase(), "img/Sipka.gif");
		imgInfo = getImage(getCodeBase(), "img/Info.gif");
		imgTren = getImage(getCodeBase(), "img/Tren.gif");
		imgKlas = getImage(getCodeBase(), "img/Klas.gif");
		imgMorse = getImage(getCodeBase(), "img/Morse.gif");
		String s1, s2;
		for (i=0; i<4; i++) {
			s1 = "img/tl/Zalozka"+i+"Off.gif";
			s2 = "img/tl/Zalozka"+i+"On.gif";
	    imgZalozky[0][i]	= getImage(getCodeBase(), s1);
	    imgZalozky[1][i]	= getImage(getCodeBase(), s2);
		}
		imgZalozkyLast = getImage(getCodeBase(), "img/tl/ZalozkaLastOff.gif");
    tracker = new MediaTracker(this); //paCanvas2
    tracker.addImage(imgUvod, 0);
		for (i=0; i<4; i++) {
			tracker.addImage(imgZalozky[0][i], 0);
			tracker.addImage(imgZalozky[1][i], 1);
		}
    //tracker.addImage(imgInfo, 2);
    //tracker.addImage(imgTren, 3);
    //tracker.addImage(imgKlas, 3);
    //tracker.addImage(imgMorse, 3);
    tracker.addImage(imgKlicOff, 3);
    tracker.addImage(imgKlicOn, 3);
    tracker.addImage(imgRewindOff, 3);
    tracker.addImage(imgRewindOn, 3);
    tracker.addImage(imgPlayOff, 3);
    tracker.addImage(imgPlayOn, 3);
    tracker.addImage(imgRecordOff, 3);
    tracker.addImage(imgRecordOn, 3);
    tracker.addImage(imgDalsiOff, 3);
    tracker.addImage(imgDalsiOn, 3);
    tracker.addImage(imgZpetOff, 3);
    tracker.addImage(imgZpetOn, 3);
    tracker.addImage(imgTrenOff, 3);
    tracker.addImage(imgTrenOn, 3);
    tracker.addImage(imgPodrobOff, 4);
    tracker.addImage(imgPodrobOn, 4);
    tracker.addImage(imgZalozkyLast, 4);
    tracker.addImage(imgSipka, 4);
//    trackerThread = new Tracker(this);
//    trackerThread.start();

    // Inicializace vsech komponent
    zalozky = new Zalozky(this);
    zalozkyImg = createImage(120, 300);
    zalozkyGr = zalozkyImg.getGraphics();
    zalozky.setBackground(barvaPozadi);
    zalozkyGr.setColor(barvaPozadi);
    zalozkyGr.drawRect(0, 0, 120, 300);
    zalozky.repaint();

    panel1 = new Panel() {
      public Dimension  getPreferredSize() { return new Dimension(500, 300); }
      public void	update(Graphics g) { paint(g); }
      public void	paint( Graphics g) { 
				if (panelImg1 == null) {
				  panelImg1 = createImage(500, 300);
				  panelGr1 = panelImg1.getGraphics();
				  clipBad.play();
				}
				super.paint(panelGr1);
				g.drawImage(panelImg1, 0, 0, this);
      }
    };
    panelImg1 = createImage(500, 300);
    panelGr1 = panelImg1.getGraphics();
    panel1.setBackground(barvaPozadi);
    panel1.repaint();
    
    panel2 = new Panel() {
      public Dimension	getPreferredSize() { return new Dimension(500, 60); }
      public void	update(Graphics g) { paint(g); }
      public void	paint( Graphics g) { 
	if (panelImg2 == null) {
	  panelImg2 = createImage(500, 60);
	  panelGr2 = panelImg2.getGraphics();
	  clipBad.play();
	}
	super.paint(panelGr2);
	g.drawImage(panelImg2, 0, 0, this);
      }
    }; 
    panelImg2 = createImage(500, 60);
    panelGr2 = panelImg2.getGraphics();
    panel2.setBackground(barvaPozadi);
    panel2.repaint();
    
    panel3 = new Panel() {
      public Dimension	getPreferredSize() { return new Dimension(500, 360); }
      public void	update(Graphics g) { paint(g); }
      public void	paint( Graphics g) { 
	if (panelImg3 == null) {
	  panelImg3 = createImage(500, 360);
	  panelGr3 = panelImg3.getGraphics();
	  clipBad.play();
	}
	super.paint(panelGr3);
	g.drawImage(panelImg3, 0, 0, this);
      }
    }; 
    panelImg3 = createImage(500, 360);
    panelGr3 = panelImg3.getGraphics();
    panelGr3.setColor(barvaPozadi);      //smazani nobo-li prebarveni na barvu pozadi
    panelGr3.fillRect(0, 0, 500, 360);   //DOLE se to opakuje -> spravit
		panel3.setBackground(barvaPozadi);
    panel3.repaint();
 
    severni = new Panel() {
      public Dimension getPreferredSize() { return new Dimension(500, 180); }
      public void	update(Graphics g) { paint(g); }
      public void	paint( Graphics g) { 
	if (severniImg == null) {
	  severniImg = createImage(500, 180);
	  severniGr = severniImg.getGraphics();
	  clipBad.play();
	}
	super.paint(severniGr);
	g.drawImage(severniImg, 0, 0, this);
      }
    };
    severni.setBackground(barvaPozadi);
    severniImg = createImage(500,180);
    severniGr = severniImg.getGraphics();
    jizni   = new Panel() {
      public Dimension getPreferredSize() { return new Dimension(500, 60); }
      public void	update(Graphics g) { paint(g); }
      public void	paint( Graphics g) { 
	if (jizniImg == null) {
	  jizniImg = createImage(500, 60);
	  jizniGr = jizniImg.getGraphics();
	  clipBad.play();
	}
	super.paint(jizniGr);
	g.drawImage(jizniImg, 0, 0, this);
      }
    };
    jizni.setBackground(barvaPozadi);
    jizniImg = createImage(500,60);
    jizniGr = jizniImg.getGraphics();
    jizniGr.setColor(barvaPozadi);
    jizniGr.fillRect(0, 0, 500, 60);
    jizni.repaint();
    zapadni = new Panel() {
      public Dimension getPreferredSize() { return new Dimension(150, 120); }
      public void	update(Graphics g) { paint(g); }
      public void	paint( Graphics g) { 
	if (zapadniImg == null) {
	  zapadniImg = createImage(150, 120);
	  zapadniGr = zapadniImg.getGraphics();
	  clipBad.play();
	}
	//super.paint(zapadni.getGraphics());
	super.paint(zapadniGr);
	g.drawImage(zapadniImg, 0, 0, this);
	//super.paint(g);
      }
    };
    zapadniImg = createImage(150,120);
    zapadniGr = zapadniImg.getGraphics();
    zapadni.setBackground(barvaPozadi);
    vychodni= new Panel() {
      public Dimension getPreferredSize() { return new Dimension(200, 120); }
      public void	update(Graphics g) { paint(g); }
      public void	paint( Graphics g) { 
				if (vychodniImg == null) {
				  vychodniImg = createImage(200, 120);
				  vychodniGr = vychodniImg.getGraphics();
					//vychodniGr.setColor(barvaPozadi);
					//vychodniGr.fillRect(0, 0, 200, 120);
				  clipBad.play();
				}
				super.paint(vychodniGr);
				g.drawImage(vychodniImg, 0, 0, this);
      }
    };
    vychodniImg = createImage(200,120);
    vychodniGr = vychodniImg.getGraphics();
    vychodni.setBackground(barvaPozadi);
    stredni = new Panel() {
      public Dimension getPreferredSize() { return new Dimension(150, 120); }
      public void	update(Graphics g) { paint(g); }
      public void	paint( Graphics g) { 
	if (stredniImg == null) {
	  stredniImg = createImage(150, 120);
    stredni.getGraphics().setColor(Color.black);
    stredni.getGraphics().drawRect(0, 0, 150, 120);
    stredniGr.setColor(Color.black);
    stredniGr.drawRect(0, 0, 150, 120);
	  stredniGr = stredniImg.getGraphics();
	  clipBad.play();
	}
	super.paint(stredniGr);
	g.drawImage(stredniImg, 0, 0, this);
      }
    };
    stredniImg = createImage(150,120);
    stredniGr = stredniImg.getGraphics();
    stredni.setBackground(barvaPozadi);
    stredniGr.setColor(barvaPozadi);
    stredniGr.fillRect(0, 0, 150, 120);
    stredniGr.setColor(Color.black);
    stredniGr.drawRect(0, 0, 150, 120);
    stredni.repaint();


/***********************************************************/
/********************   TLACITKA   *************************/
/***********************************************************/

    klic = new Klic(imgKlicOff, imgKlicOn, "Klic", clipPip, this);
    bTrenovat = new ImageButton(imgTrenOff, imgTrenOn, "Trenovat");
    bTrenovat.setVisible(true);
    bTrenovat.addActionListener( new ActionListener() {
      public void actionPerformed(ActionEvent e) {
				showStatus("Trenovat");
				kolikatyTrenink = 0;
				kolikatyZnak = 0; //zrusi aktualni trenink
				konecTrenovani = false;
				vykresliProgresBar(0);
				for (int \u00ED=0; \u00ED < pocetIntervalu; \u00ED++) {
				  poleNatrenovanychCetnosti[0][\u00ED] = 0;
				  poleNatrenovanychCetnosti[1][\u00ED] = 0;
				}
				stredniGr.setColor(barvaPozadi);
				stredniGr.fillRect(0, 0, 150, 120);
				stredni.repaint();
				jizni.remove(bPodrobnosti);
				jizni.doLayout();
				jizniGr.setColor(barvaPozadi);
				jizniGr.fillRect(0, 0, 500, 60);
				jizniGr.setColor(Color.black);
				jizniGr.setFont(new Font("Helvetica", Font.BOLD, 14));
				jizniGr.drawString("Nen\u00ED dostate\u010Dn\u011B natr\u00E9nov\u00E1no.", 20, 40);
				jizni.repaint();
		}});
	  bPodrobnosti = new ImageButton(imgPodrobOff, imgPodrobOn, "Podrobnosti");
    bPodrobnosti.setVisible(true);
    bPodrobnosti.addActionListener( new ActionListener() {
      public void actionPerformed(ActionEvent e) {
			showStatus("PODROBNOSTI");
			if (aktivniOkno == 2) {
				showStatus("Podrobnosti..");
		    trener = new Trener((Morse)morse);
		    trener.start();
		  }
			if (aktivniOkno == 3) {
				showStatus("Podrobnosti..");
		    klasifikator = new Klasifikator((Morse)morse);
		    klasifikator.start();
		  }
    }});

		bDalsi = new ImageButton(imgDalsiOff, imgDalsiOn, "Dalsi");
    bDalsi.setVisible(true);
    bDalsi.addActionListener( new ActionListener() {
      public void actionPerformed(ActionEvent e) {
				showStatus("DALSI");
				if (aktivniOkno == 2) 
						if (trener.aktivniOkno < 9) {
							showStatus("Akt Okno v TRENER:"+trener.aktivniOkno);
							trener.smaz();
							trener.aktivniOkno++;
							if (trener.aktivniOkno > 9) 
								trener.aktivniOkno = 9;  //a monitoru netreba :-)
						  trener.resume();
						}
				if (aktivniOkno == 3) 
						if (klasifikator.aktivniOkno < 2) {
							klasifikator.smaz();
							klasifikator.aktivniOkno++;
						  klasifikator.resume();
						}
   }});
    bZpet = new ImageButton(imgZpetOff, imgZpetOn, "Zpet");
    bZpet.setVisible(true);
	    bZpet.addActionListener( new ActionListener() {
	      public void actionPerformed(ActionEvent e) {
					showStatus("ZPET");
					if (aktivniOkno == 2)
						if (trener.aktivniOkno > 1) {
							trener.smaz();
							trener.aktivniOkno--;
							trener.resume();
						}
					if (aktivniOkno == 3)
						if (klasifikator.aktivniOkno > 1) {
							//klasifikator.interrupt();
							//klasifikator.dokonciDemo();
							//Vyuziju toho, ze mam jen 2 obrazovky a z toho ta druha
							//je uspavana a prvni je OK:
							klasifikator.stop();
					    klasifikator = new Klasifikator((Morse)morse);
							klasifikator.start();
							//klasifikator.smaz();
							//klasifikator.aktivniOkno--;
							//klasifikator.resume();
						}
    }});
		bRewind = new ImageButton(imgRewindOff, imgRewindOn, "<<");
    bRewind.setVisible(true);
    bRewind.addActionListener( new ActionListener() {
     public void actionPerformed(ActionEvent e) {
      showStatus("<<");
      stredniGr.setColor(barvaPozadi);
			stredniGr.fillRect(0, 0, 150, 120);
			stredni.repaint();

			 if (aktivniOkno == 2) {
	      //stredniGr.setColor(Color.green.darker());;
				//if (kolikatyZnak!=0) {
				if (kolikatyZnak > 9) {
					for (int ii = 1; ii < 4; ii++) { //SOS = 3 tecky (012), 3 carky (345) ... 
					  if ((ii     <= kolikatyZnak)|| ((kolikatyZnak==0)&&(kolikatyTrenink>0))) poleNatrenovanychCetnosti[0][(int)((polePriznaku[ii])/velKroku)]--;
					  if (((ii+3) <= kolikatyZnak)|| ((kolikatyZnak==0)&&(kolikatyTrenink>0))) poleNatrenovanychCetnosti[1][(int)((polePriznaku[ii+3])/velKroku)]--;
					  if (((ii+6) <= kolikatyZnak)|| ((kolikatyZnak==0)&&(kolikatyTrenink>0))) poleNatrenovanychCetnosti[0][(int)((polePriznaku[ii+6])/velKroku)]--;
					}  
					kolikatyZnak = 0;
					//if ((kolikatyTrenink>0)&&((kolikatyZnak==9)||(kolikatyZnak==0)))
					if ((kolikatyTrenink>0))
						kolikatyTrenink--; // tj. je natrenovan vsech 9 a zvedl se pocet priznaku
					vykresliProgresBar(kolikatyTrenink);								
					for (int j = 1; j < 10; j++) //magicka hodnota 10 znaku
					  polePriznaku[j] = 0;
					// tohle by nikdy nemelo nastat:	
					if (kolikatyTrenink < minPocetTreninku) {
						jizni.remove(bPodrobnosti);
						jizni.doLayout();
						jizniGr.setColor(barvaPozadi);
						jizniGr.fillRect(0, 0, 500, 60);
						jizniGr.setColor(Color.black);
						jizniGr.setFont(new Font("Helvetica", Font.BOLD, 14));
						jizniGr.drawString("Nen\u00ED dostate\u010Dn\u011B natr\u00E9nov\u00E1no.", 20, 40);
						jizni.repaint();
					}
				}	
			 } else {
				if (aktivniOkno == 3) {
					kolikatyZnak = 0;
					for (int j = 1; j < 10; j++) //magicka hodnota 10 znaku
					  polePriznaku[j] = 0;
			}	}		
    }});
		bRecord = new ImageButton(imgRecordOff, imgRecordOn, "o");
    bRecord.setVisible(true);
    bRecord.addActionListener( new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        showStatus("o");
        kolikatyZnak = 1; //budeme nahravat pekne od zacatku
        stredniGr.setColor(barvaPozadi);
				stredniGr.fillRect(0, 0, 150, 120);
				stredni.repaint();
				for (int j = 1; j < 10; j++) { //magicka hodnota 10 znaku
				  polePriznaku[j] = 0;
					poleZnaku[j] = '?';
				}
				showStatus("Recording ...");
    }});
		bPlay = new ImageButton(imgPlayOff, imgPlayOn, ">");
    bPlay.setVisible(true);
    bPlay.addActionListener( new ActionListener() {
      public void actionPerformed(ActionEvent e) {
				int uschovna = kolikatyZnak;
				if (uschovna==0) 
					uschovna = 10;
				showStatus(">");
				if (kolikatyTrenink>1) {  // riziko if klasifik a namam natrenovano
//				  animator = new Animator((Morse)morse);
//				  stredniGr.setColor(barvaPozadi);
//				  stredniGr.fillRect(0, 0, 150, 120);
//					stredni.update(stredniGr);
//				  stredniGr.setColor(Color.blue.brighter().brighter().brighter());
				  for (kolikatyZnak = 1; kolikatyZnak < uschovna; kolikatyZnak++) { // NUTNO JAKO VLAKNO
				    clipPip.loop();
//				    animator.start();
				    try {
				      Thread.sleep(polePriznaku[kolikatyZnak]);
				    } catch(InterruptedException ie) {}
//				    animator.stop();
				    clipPip.stop();
			 	    try {
				      Thread.sleep(300);
				    } catch(InterruptedException ie) {}
				  }//for
					kolikatyZnak = uschovna;
				} else { //if 
					showStatus("Nahrano nula znaku-> nic neprehravam");
				}
    }});
    
		vychodni.setLayout(new FlowLayout(FlowLayout.LEFT, 10, 15));
		vychodni.setBackground(barvaPozadi);
		
    zapadni.setLayout(new FlowLayout(FlowLayout.LEFT, 15, 15));
    zapadni.add(klic);
    zapadni.add(bRewind);
    zapadni.add(bRecord);
    zapadni.add(bPlay);
    zapadni.doLayout();
		zapadniGr.setColor(Color.black);
		zapadniGr.drawRect(0, 0, 149, 119);
    
    setLayout(new BorderLayout(0, 0));
    setBackground(barvaPozadi);
    add(zalozky, "West");
    add(panel3, "Center");
		
		//zacatek stahovani obrazku ////////////////////
    trackerThread = new Tracker(this);
    trackerThread.start();

	// natrenovani po startu
	kolikatyTrenink += 5;
	poleNatrenovanychCetnosti[0][0]+=8;
	poleNatrenovanychCetnosti[0][1]+=11;
	poleNatrenovanychCetnosti[0][2]+=6;
	poleNatrenovanychCetnosti[0][3]+=3;
	poleNatrenovanychCetnosti[0][4]+=1;
	poleNatrenovanychCetnosti[0][5]+=1;
	poleNatrenovanychCetnosti[0][6]+=0;
	poleNatrenovanychCetnosti[0][7]+=0;
	poleNatrenovanychCetnosti[0][8]+=0;
	poleNatrenovanychCetnosti[0][9]+=0;
	poleNatrenovanychCetnosti[1][0]+=0;
	poleNatrenovanychCetnosti[1][1]+=1;
	poleNatrenovanychCetnosti[1][2]+=2;
	poleNatrenovanychCetnosti[1][3]+=4;
	poleNatrenovanychCetnosti[1][4]+=2;
	poleNatrenovanychCetnosti[1][5]+=2;
	poleNatrenovanychCetnosti[1][6]+=1;
	poleNatrenovanychCetnosti[1][7]+=1;
	poleNatrenovanychCetnosti[1][8]+=1;
	poleNatrenovanychCetnosti[1][9]+=1;
	spoctiPpsti();
	
	jizni.removeAll();
	jizni.setLayout(new FlowLayout(FlowLayout.RIGHT, 7, 7));
	jizni.doLayout();
  }//end init()
  
/***********************************************************************/
/***********************************************************************/
/***********************************************************************/

	public void setKolikatyZnak(int i) {
    kolikatyZnak = i;
  }
  public int getKolikatyZnak() {
    return kolikatyZnak;
  }
  public void setKolikatyTrenink(int i) {
    kolikatyTrenink = i;
  }
  public int getKolikatyTrenink() {
    return kolikatyTrenink;
  }

  public void spoctiPpsti() {
    int i, j; 
    for (i = 0; i < pocetIntervalu; i++) {
      //ted pocitam P(x|wi)
      poleNatrenovanychPpsti[0][i] = poleNatrenovanychCetnosti[0][i] /
																			(float)(kolikatyTrenink*6.0);
      poleNatrenovanychPpsti[1][i] = poleNatrenovanychCetnosti[1][i] /
																			(float)(kolikatyTrenink*3.0);
      //ted pocitam N(x)
      poleNatrenovanychCetnostiX[i] = (poleNatrenovanychCetnosti[0][i] +
																			poleNatrenovanychCetnosti[1][i] );
      //ted pocitam P(x) ... a to zcela zbytecne ... tuto hodnotu nepotrebuji
      poleNatrenovanychPpstiX[i] = (poleNatrenovanychPpsti[0][i]*poleApriornichPpsti[0] +
																		poleNatrenovanychPpsti[1][i]*poleApriornichPpsti[1] );
      //ted pocitam P(wi|x)
			if (poleNatrenovanychPpstiX[i]!=0) { // vsechno je OK
      	poleAposteriornichPpsti[0][i] = ( poleNatrenovanychPpsti[0][i] *
				poleApriornichPpsti[0] ) / poleNatrenovanychPpstiX[i];
	      poleAposteriornichPpsti[1][i] = ( poleNatrenovanychPpsti[1][i] *
				poleApriornichPpsti[1] ) / poleNatrenovanychPpstiX[i];
			}	else { // nebudeme delit nulou
				poleAposteriornichPpsti[0][i] = 0;
				poleAposteriornichPpsti[1][i] = 0;
			}	
    }
  }

  public void zpracujDobuTrvani(long doba) {
		if (doba < maxDelkaZnaku)				// nez 1000 ms
		  polePriznaku[kolikatyZnak] = doba;
		else 
		  polePriznaku[kolikatyZnak] = maxDelkaZnaku-1 ;  //dam 999 a nepretece pole
    if (aktivniOkno == 2) {
      if (kolikatyZnak == 9) { // je jich vsech 9 (...---...) ?
				for (int i = 1; i < 4; i++) { //SOS = 3 tecky (012), 3 carky (345) ... 
				  poleNatrenovanychCetnosti[0][(int)((polePriznaku[i])/velKroku)]++;
				  poleNatrenovanychCetnosti[1][(int)((polePriznaku[i+3])/velKroku)]++;
				  poleNatrenovanychCetnosti[0][(int)((polePriznaku[i+6])/velKroku)]++;
				}  
				kolikatyZnak = 10;  // DIVOKA ZMENA
				kolikatyTrenink++;  // dalsi trenik je kompletne hotov
				vykresliProgresBar(kolikatyTrenink);
				if (kolikatyTrenink >= minPocetTreninku) {
					jizni.setLayout(new FlowLayout(FlowLayout.RIGHT, 7, 7));
					jizni.add(bPodrobnosti);
					//doLayout();
					//panel3.doLayout();
					jizni.doLayout();
					//				jizniGr.setColor(barvaPozadi);
					jizniGr.setColor(barvaPozadi);
					jizniGr.fillRect(0, 0, 500, 60);
					jizniGr.setColor(Color.black);
					jizniGr.setFont(new Font("Helvetica", Font.BOLD, 14));
					jizniGr.drawString("Je dostate\u010Dn\u011B natr\u00E9nov\u00E1no.", 20, 40);
					jizni.repaint();
				} 
			} else
	    kolikatyZnak++;
    } 
		if (aktivniOkno == 3) {          
			//jizni.setLayout(new FlowLayout(FlowLayout.RIGHT, 7, 7));
			//jizni.add(bDalsi);
			//jizni.doLayout();
			//Napis carky a tecky do vychodnich okna
			nakresliPismeno();
			kolikatyZnak++;
		}
  }

	public void klasifikuj() {
		for (int i = 1; i <= kolikatyZnak; i++) {
			if (poleAposteriornichPpsti[0][(int)(polePriznaku[i]/100)] < poleAposteriornichPpsti[1][(int)(polePriznaku[i]/100)])
				poleZnaku[i] = '-'; //carka
			else
				if (poleAposteriornichPpsti[0][(int)(polePriznaku[i]/100)] > poleAposteriornichPpsti[1][(int)(polePriznaku[i]/100)]) 
					poleZnaku[i] = '.'; //tecka
				else {// jsou si rovny				
					poleZnaku[i] = '?'; // nevime co to je
					showStatus("Neumim rozhodnout, stejne Aposteriorni Ppsti");
					clipBad.play();
				}//else
		}
	}

	public void nakresliPismeno() {
		int k;  // promen cyklu
		klasifikuj();
		vychodniGr.setColor(barvaPozadi);
		vychodniGr.fillRect(0, 0, 200, 120);
		vychodniGr.setColor(Color.black);
		vychodniGr.setFont(new Font("Helvetica", Font.BOLD, 14));
		if (kolikatyTrenink >= minPocetTreninku) {
			vychodniGr.drawString("Klasifik\u00E1tor roz- ", 20, 30);
			vychodniGr.drawString("poznal posloupnost ", 20, 45);
			vychodniGr.drawString("znak\u016F: ", 20, 60);
			vychodniGr.setColor(Color.red);
			for (k = 1; k <= kolikatyZnak; k++) {
				if (poleZnaku[k]=='-') 
					vychodniGr.fillRect(50+k*20, 52, 15, 7);
				else 
					if (poleZnaku[k]=='.') 
						vychodniGr.fillOval(50+k*20+4, 52, 7, 7);
					else { // tj. je to nedefeinovana znacka
						vychodniGr.setColor(barvaPozadi);
						vychodniGr.fillRect(0, 0, 200, 120);
						vychodniGr.setColor(Color.blue);
						vychodniGr.drawString("Klasifik\u00E1tor nara-", 20, 30);
						vychodniGr.drawString("zil na zna\u010Dku ", 20, 45);
						vychodniGr.drawString("se kterou se p\u0159i", 20, 60);
						vychodniGr.drawString("tr\u00E9nov\u00E1n\u00ED nesetkal", 20, 75);
						vychodniGr.drawString("a nev\u00ED si s n\u00ED rady.",    20, 90);
						vychodni.repaint();
						showStatus("Nelze rozhodnout, zda tecka, nebo carka.");
						k = 1111; // konec FOR cyklu
						break;
					}	
							
			showStatus("kolikaty zank = "+kolikatyZnak+ " hodnota "+polePriznaku[kolikatyZnak]
					+"  P(w1|x) "+poleAposteriornichPpsti[0][(int)(polePriznaku[k]/100)]
					+"  P(w1|x) "+poleAposteriornichPpsti[1][(int)(polePriznaku[k]/100)]
					+"  pole znaku "+poleZnaku[k]);
			}
			if (k<100) {	 // neni-li to nedefinovana znacka (ani . ani -)	
				if (getPismenoMorseovyAbecedy()) {
					vychodniGr.setColor(Color.blue);
					vychodniGr.drawString("Tomuto k\u00F3du", 20, 80);
					vychodniGr.drawString("odpov\u00EDd\u00E1", 20, 95);
					vychodniGr.drawString("p\u00EDsmeno:", 20, 110);
					vychodniGr.setFont(new Font("Helvetica", Font.BOLD, 54));
					vychodniGr.setColor(Color.red);
					if (rozpoznanePismeno=="CH") // CH je moc dlouhe
						vychodniGr.drawString(rozpoznanePismeno, 115, 110);
					else 
						vychodniGr.drawString(rozpoznanePismeno, 130, 110);
					vychodniGr.setColor(Color.blue);
					vychodniGr.setFont(new Font("Helvetica", Font.BOLD, 14));
				} else {
					vychodniGr.setColor(Color.blue);
					vychodniGr.setFont(new Font("Helvetica", Font.BOLD, 14));
					vychodniGr.drawString("Takov\u00E1 posloupnost", 20, 80);
					vychodniGr.drawString("neodpov\u00EDd\u00E1 z\u00E1dn\u00E9mu", 20, 95);
					vychodniGr.drawString("p\u00EDsmenu.", 20, 110);
				}
			}
		} else { 
			vychodniGr.drawString("Nejprve je t\u0159eba", 20, 30);
			vychodniGr.drawString("klasifik\u00E1tor dosta-", 20, 45);
			vychodniGr.drawString("te\u010Dn\u011B natr\u00E9novat.", 20, 60);
			vychodniGr.drawString("Teprve pak mohu", 20, 75);
			vychodniGr.drawString("spr\u00E1vn\u011B klasifikovat.", 20, 90);
			
/*			vychodniGr.drawString("Nejprve je t\u0159eba", 20, 30);
			vychodniGr.drawString("klasifik\u00E1tor na-", 20, 45);
			vychodniGr.drawString("tr\u00E9novat. Teprve", 20, 60);
			vychodniGr.drawString("pak mohu spr\u00E1vn\u011B", 20, 75);
			vychodniGr.drawString("klasifikovat.",    20, 90);*/
		}	
		vychodni.repaint();
	}
	
	public void vykresliProgresBar (int kolikCtvercu) {
		vychodniGr.setColor(barvaPozadi);
		vychodniGr.fillRect(10, 62, 180, 25);
		vychodniGr.setColor(Color.black);
		vychodniGr.setFont(new Font("Helvetica", Font.BOLD, 16));
		vychodniGr.drawString("Natr\u00E9nov\u00E1no: "+kolikCtvercu+" z 10", 10, 80);
		vychodniGr.setColor(Color.gray.brighter());
		vychodniGr.fill3DRect(10, 85, 180, 25, false);
		for (int k = 0; k < 10; k++) {
			if (k < kolikCtvercu) {
				vychodniGr.setColor(Color.blue.brighter().brighter());
			} else {
				vychodniGr.setColor(Color.gray.brighter());
			}
			vychodniGr.fill3DRect(16+k*17, 90, 15, 15, true);
		}
		vychodni.repaint();
	}

	boolean getPismenoMorseovyAbecedy() {
		String s = "";
		//poleZnaku zacina od 1
		if (poleZnaku[1]=='?')
			return false;
		else {
			if (poleZnaku[1]=='.')  {
				rozpoznanePismeno ="E";

				if (poleZnaku[2]=='?') 
					return true; // a v promenen rozopznanePismeno je bud T nebo E
				else {
					if (poleZnaku[2]=='.') { 
						rozpoznanePismeno ="I";
						//uz mame ".."						
						if (poleZnaku[3]=='?') 
							return true; // a v promenen rozopznanePismeno je bud T nebo E
						else {
							if (poleZnaku[3]=='.') { 
								rozpoznanePismeno ="S";
								//uz mame "..."						
								if (poleZnaku[4]=='?') 
									return true; // a v promenen rozopznanePismeno je bud T nebo E
								else {
									if (poleZnaku[4]=='.') { 
										rozpoznanePismeno ="H";
									} else {
										if (poleZnaku[4]=='-') { 
											rozpoznanePismeno ="V";
										}	
									}
								}	
							} else {
								if (poleZnaku[3]=='-') { 
									rozpoznanePismeno ="U";
									//uz mame "..-"						
									if (poleZnaku[4]=='?') 
										return true; // a v promenen rozopznanePismeno je bud T nebo E
									else {
										if (poleZnaku[4]=='.') { 
											rozpoznanePismeno ="F";
										} else {
											if (poleZnaku[4]=='-') { 
												rozpoznanePismeno ="?";
												return false;
											}	
										}
									}	
								}	
							}
						}	
					} else {
						if (poleZnaku[2]=='-') { 
							rozpoznanePismeno ="A";
							//uz mame ".-"						
							if (poleZnaku[3]=='?') 
								return true; // a v promenen rozopznanePismeno je bud T nebo E
							else {
								if (poleZnaku[3]=='.') { 
									rozpoznanePismeno ="R";
									//uz mame ".-."						
									if (poleZnaku[4]=='?') 
										return true; // a v promenen rozopznanePismeno je bud T nebo E
									else {
										if (poleZnaku[4]=='.') { 
											rozpoznanePismeno ="L";
										} else {
											if (poleZnaku[4]=='-') { 
												rozpoznanePismeno ="?";
												return false;
											}	
										}
									}	
								} else {
									if (poleZnaku[3]=='-') { 
										rozpoznanePismeno ="W";
										//uz mame ".--"						
										if (poleZnaku[4]=='?') 
											return true; // a v promenen rozopznanePismeno je bud T nebo E
										else {
											if (poleZnaku[4]=='.') { 
												rozpoznanePismeno ="P";
											} else {
												if (poleZnaku[4]=='-') { 
													rozpoznanePismeno ="J";
												}	
											}
										}	
									}	
								}
							}	
						}	
					}
				}	
			}
			
			//druha polvina procedurtu pro pismena zacinajici na carku:
			if (poleZnaku[1]=='-')  {
				rozpoznanePismeno ="T";

				if (poleZnaku[2]=='?') 
					return true; // a v promenen rozopznanePismeno je bud T nebo E
				else {
					if (poleZnaku[2]=='.') { 
						rozpoznanePismeno ="N";
						//uz mame "-."						
						if (poleZnaku[3]=='?') 
							return true; // a v promenen rozopznanePismeno je bud T nebo E
						else {
							if (poleZnaku[3]=='.') { 
								rozpoznanePismeno ="D";
								//uz mame "-.."						
								if (poleZnaku[4]=='?') 
									return true; // a v promenen rozopznanePismeno je bud T nebo E
								else {
									if (poleZnaku[4]=='.') { 
										rozpoznanePismeno ="B";
									} else {
										if (poleZnaku[4]=='-') { 
											rozpoznanePismeno ="X";
										}	
									}
								}	
							} else {
								if (poleZnaku[3]=='-') { 
									rozpoznanePismeno ="K";
									//uz mame "-.-"						
									if (poleZnaku[4]=='?') 
										return true; // a v promenen rozopznanePismeno je bud T nebo E
									else {
										if (poleZnaku[4]=='.') { 
											rozpoznanePismeno ="C";
										} else {
											if (poleZnaku[4]=='-') { 
												rozpoznanePismeno ="Y";
												return false;
											}	
										}
									}	
								}	
							}
						}	
					} else {
						if (poleZnaku[2]=='-') { 
							rozpoznanePismeno ="M";
							//uz mame "--"						
							if (poleZnaku[3]=='?') 
								return true; // a v promenen rozopznanePismeno je bud T nebo E
							else {
								if (poleZnaku[3]=='.') { 
									rozpoznanePismeno ="G";
									//uz mame "--."						
									if (poleZnaku[4]=='?') 
										return true; // a v promenen rozopznanePismeno je bud T nebo E
									else {
										if (poleZnaku[4]=='.') { 
											rozpoznanePismeno ="Z";
										} else {
											if (poleZnaku[4]=='-') { 
												rozpoznanePismeno ="Q";
											}	
										}
									}	
								} else {
									if (poleZnaku[3]=='-') { 
										rozpoznanePismeno ="O";
										//uz mame "---"						
										if (poleZnaku[4]=='?') 
											return true; // a v promenen rozopznanePismeno je bud T nebo E
										else {
											if (poleZnaku[4]=='.') { 
												rozpoznanePismeno ="?";
												return false;
											} else {
												if (poleZnaku[4]=='-') { 
													rozpoznanePismeno ="CH";
												}	
											}
										}	
									}	
								}
							}	
						}	
					}
				}	
			}
		} //else [1]
		return true;	 //Uff to je zavorek ...
	}
		
				
}// end class Morse


/*****************************************************************/
/*****************************************************************/
/*****************************************************************/

		